-- The sound effects provided are just sounds I found for free online and they are in no way mine.

_, class = UnitClass("player")
if class == "MAGE" then

function MCCopy()
for idx = 1, #MageCandy_Profiles do
MageCandy_Profiles[idx].options = MageCandy_Profiles[1].options
end
end

MCAuraEvents = {
["SPELL_AURA_APPLIED"] = true,
["SPELL_AURA_REMOVED"] = true,
["SPELL_AURA_APPLIED_DOSE"] = true,
["SPELL_AURA_REMOVED_DOSE"] = true,
["SPELL_AURA_REFRESH"] = true,
}

MCDamageEvents = {
["SPELL_DAMAGE"] = true,
["SWING_DAMAGE"] = true,
["RANGE_DAMAGE"] = true,
["SPELL_PERIODIC_DAMAGE"] = true,
["ENVIRONMENTAL_DAMAGE"] = true,
}

MCHealEvents = {
["SPELL_HEAL"] = true, 
["SPELL_PERIODIC_HEAL"] = true,
}

MCIgniteSpells = {
[108853] = true, -- inferno blast
[133] = true, -- fireball
[11366] = true, -- pyroblast
[2948] = true, -- scorch
[44614] = true, -- frostfire bolt
}


local loaded = false
local mctimerthrottle, mctimer = 1, 0
MCcombustionmultiplier = 1
MCSpec = ""


--Localization------------------------------------------

local locale = GetLocale()
if locale == "enUS" then
MageCandyLocal = MageCandyenUS
elseif locale == "deDE" then -- German
MageCandyLocal = MageCandydeDE
elseif locale == "enGB" then -- British English
MageCandyLocal = MageCandyenGB
elseif locale == "esES" then -- Spanish
MageCandyLocal = MageCandyesES
elseif locale == "esMX" then -- Spanish(Mexixo)
MageCandyLocal = MageCandyesMX
elseif locale == "frFR" then -- French
MageCandyLocal = MageCandyfrFR
elseif locale == "koKR" then -- Korean
MageCandyLocal = MageCandykoKR
elseif locale == "ruRU" then -- Russian
MageCandyLocal = MageCandyruRU
elseif locale == "zhCN" then -- Simplified Chinese
MageCandyLocal = MageCandyzhCN
elseif locale == "zhTW" then -- Traditional Chinese
MageCandyLocal = MageCandyzhTW
else
print("Localization Not Found")
MageCandyLocal = MageCandyenUS
end

----------------------------------------------------------

function MageCandy_MCTimerOnUpdate(self, elapsed)

MageCandy_PolymorphOnUpdate(elapsed)
MageCandy_ManaBarOnUpdate(elapsed)
MageCandy_TrackersOnUpdate(elapsed)
MageCandy_NotificationsHandler(elapsed)
MageCandy_UpdateTimers(elapsed)
if MCSpellStealNotification:IsShown() and MCtimerbypass == 0 then
MageCandy_MCSpellStealNotificationOnUpdate(elapsed)
end

if MCtimerbypass > 0 then
MCtimerbypass = MCtimerbypass - elapsed
MCPolymorphMonitorBarText:SetText(string.sub(MCtimerbypass, 1, 4))
MCPolymorphMonitorBar:SetValue(MCtimerbypass)
if MCtimerbypass <= 0 then
MageCandy_LockFrames()
MCtimerbypass = 0
MCPolymorphMonitor:Hide()
MCPolymorphMonitorBar:SetValue(0)
MCPolymorphMonitorBarText:SetText(0)
MageCandy_HideFrames()
MageCandy_UpdateUI()
end
end

mctimer = mctimer + elapsed
if mctimer >= mctimerthrottle then
mctimer = 0
if UnitAffectingCombat("player") == 1 and loaded == true and MCtimerbypass == 0 and MCCombat == nil then
MageCandy_UpdateUI(false)
MageCandy_LockFrames()
MCCombat = 1
elseif loaded == true and MCtimerbypass == 0 and UnitAffectingCombat("player") == nil and MCCombat == 1 then
MageCandy_UnlockFrames()
MCCombat = nil
if MageCandy_Profiles[MageCandy_ActiveProfile].options.hideframes == 1 and MCtimerbypass == 0 and UnitAffectingCombat("player") == nil then
MageCandy_UpdateUI(true)
end
end
end

end


MageCandyEventFrame = CreateFrame("Frame", "MageCandyEventFrame", UIParent)
MageCandyEventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
MageCandyEventFrame:RegisterEvent("ADDON_LOADED")
MageCandyEventFrame:RegisterEvent("PLAYER_ALIVE")
MageCandyEventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
MageCandyEventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
MageCandyEventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
MageCandyEventFrame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
MageCandyEventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")




function MageCandy_Round(number, decimals)
return tonumber((("%%.%df"):format(decimals)):format(number))
end


function MageCandy_OnEvent(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16)

if event == "ADDON_LOADED" and arg1 == "MageCandy" then
MageCandy_Check(true)
MageCandy_CreateManaBarUI()
MageCandy_CreateTimersUI()
MageCandy_CreateNotificationsUI()
MageCandy_CreatePolymorphMonitorUI()
MageCandy_CreateSpellStealMonitorUI()
MageCandy_CreateTrackersUI()
MageCandy_CreateCastingBarFrameMover()
MageCandy_CreateOptionsMenu()
MageCandy_CreateManaBarOptionsMenu()
MageCandy_CreateTimersOptionsMenu()
MageCandy_CreateNotificationsOptionsMenu()
MageCandy_CreatePolymorphMonitorOptionsMenu()
MageCandy_CreateSpellStealMonitorOptionsMenu()
MageCandy_CreateTrackersOptionsMenu()
MageCandy_FinishOptionsMenu()
MageCandy_UpdateProfile()
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile].clicked = true
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile.."Highlight"]:Show()
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile.."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G["MCProfileFrameContentButton"..MageCandy_ActiveProfile.."Text"]:SetTextColor(1, 1, 1)
MageCandy_Cancel() -- applies scaling & saved text into input boxes
MageCandy_TimerHandler()
MageCandy_UpdateUI()
loaded = true
print("|cff00dfff"..MageCandyLocal["SLASH"].."|r")
end
if event == "PLAYER_ENTERING_WORLD" then
MageCandy_OnEvent(nil, "PLAYER_SPECIALIZATION_CHANGED")
MageCandy_PlaceFrames()
MageCandy_HealthBarUpdate()
MageCandy_ManaBarUpdate()
MageCandy_UpdateStats()
MageCandy_WaterElementalTrackerOnEvent(nil, "UNIT_HEALTH", "pet")
MageCandy_WaterElementalTrackerOnEvent(nil, "UNIT_PET", "player")
MageCandy_WaterElementalTrackerOnEvent(nil, "UNIT_TARGET", "pet")
--MageCandy_WaterElementalTrackerOnEvent(nil, "UNIT_POWER", "pet")
if MageCandy_Profiles[MageCandy_ActiveProfile].options.hideframes == 1 and MCtimerbypass == 0 and UnitAffectingCombat("player") == nil then
MageCandy_UpdateUI(true)
else
MageCandy_UpdateUI()
end
end

if event == "PLAYER_SPECIALIZATION_CHANGED" or event == "ACTIVE_TALENT_GROUP_CHANGED" then
MCInvokersEnergyTimerCooldown:SetCooldown(0, 0)
MCRuneOfPower1TimerCooldown:SetCooldown(0, 0)
MageCandy_TimerHandler()
MCtier6flash = false
MCInvokersEnergyTimer:Hide()
MCRuneOfPower1Timer:Hide()
MCIncantersAbsorptionTimer:Hide()
local idx = 12
while idx < 18 do
idx = idx + 1
local name, texture, _, _, learned = GetTalentInfo(idx)
if learned == true then
if idx == 13 then
MCBombTrackerIcon:SetTexture("Interface\\Icons\\spell_mage_nethertempest")
idx = 15
elseif idx == 14 then
MCBombTrackerIcon:SetTexture("Interface\\Icons\\Ability_Mage_LivingBomb")
idx = 15
elseif idx == 15 then
MCBombTrackerIcon:SetTexture("Interface\\Icons\\spell_mage_frostbomb")
end
end
if learned == true then
if idx == 16 then
MCTier6Frame = MCInvokersEnergyTimer
MCtier6flash = true
idx = 18
elseif idx == 17 then
MCTier6Frame = MCRuneOfPower1Timer
MCtier6flash = true
idx = 18
elseif idx == 18 then
MCTier6Frame = MCIncantersAbsorptionTimer
idx = 18
end
else
MCTier6Frame = nil
end
end
if GetSpecialization() == 1 then
MCSpec = "Arcane"
elseif GetSpecialization() == 2 then
MCSpec = "Fire"
elseif GetSpecialization() == 3 then
MCSpec = "Frost"
end
MCcombustionmultiplier = 1
for idx = 1, NUM_GLYPH_SLOTS do
local available, glyphtype, glyphtooltipindex, spellid = GetGlyphSocketInfo(idx)
if spellid == 56368 then
MCcombustionmultiplier = 2
break
end
end
MageCandy_UpdateUI()
end

if event == "COMBAT_LOG_EVENT_UNFILTERED" then

if arg2 == "UNIT_DIED" and arg8 == UnitGUID("pet") and MageCandy_Profiles[MageCandy_ActiveProfile].options.sound.elementaldeath == 1 then
PlaySoundFile("Interface\\AddOns\\MageCandy\\Sounds\\elementaldeath.mp3", "MASTER")
end
if (arg2 == "SPELL_AURA_APPLIED" or arg2 == "SPELL_AURA_REFRESH" or arg2 == "SPELL_AURA_APPLIED_DOSE") and arg8 == UnitGUID("player") then
if arg12 == 44544 and MageCandy_Profiles[MageCandy_ActiveProfile].options.sound.fingersoffrost == 1 then
PlaySoundFile("Interface\\AddOns\\MageCandy\\Sounds\\fingersoffrost.mp3", "SFX")
elseif arg12 == 48108 and MageCandy_Profiles[MageCandy_ActiveProfile].options.sound.pyroblast == 1 then
PlaySoundFile("Interface\\AddOns\\MageCandy\\Sounds\\pyroblast.mp3", "SFX")
elseif arg12 == 79683 and MageCandy_Profiles[MageCandy_ActiveProfile].options.sound.arcanemissiles == 1 then
PlaySoundFile("Interface\\AddOns\\MageCandy\\Sounds\\arcanemissiles.mp3", "SFX")
elseif arg12 == 57761 and MageCandy_Profiles[MageCandy_ActiveProfile].options.sound.brainfreeze == 1 then
PlaySoundFile("Interface\\AddOns\\MageCandy\\Sounds\\brainfreeze.mp3", "MASTER")
elseif arg12 == 87023 and MageCandy_Profiles[MageCandy_ActiveProfile].options.sound.cauterize == 1 then
PlaySoundFile("Interface\\AddOns\\MageCandy\\Sounds\\cauterize.mp3", "MASTER")
end
end

if arg2 == "SPELL_CAST_SUCCESS" and arg4 == UnitGUID("player") then 
if arg12 == 130 then -- slowfall
if UnitIsPlayer(arg9) and arg8 ~= UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.slowfallmessage == 1 then
SendChatMessage(MageCandy_Profiles[MageCandy_ActiveProfile].options.input.slowfallmessage, "WHISPER", nil, arg9) 
end
elseif arg12 == 111264 then -- ice ward
if UnitIsPlayer(arg9) and arg8 ~= UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.icewardmessage == 1 then
SendChatMessage(MageCandy_Profiles[MageCandy_ActiveProfile].options.input.icewardmessage, "WHISPER", nil, arg9)
end
end
end
end

end




function MageCandy_ShortNumber(num)
if num == 0 then
return num
elseif num > 0 and num < 0.1 then
if string.sub(num, 5, 5) ~= "" and string.sub(num, 5, 5) ~= nil then
return string.sub(num,4, 4).."."..string.sub(num, 5, 5)
else
return string.sub(num,4, 4)
end
elseif num >= 0 and num < 1 then
if string.sub(num, 5, 5) ~= nil and string.sub(num, 5, 5) ~= "" then
return string.sub(num, 3, 4).."."..string.sub(num, 5, 5)
elseif num == 0.1 or num == 0.2 or num == 0.3 or num == 0.4 or num == 0.5 or num == 0.6 or num == 0.7
or num == 0.8 or num == 0.9 then
num = string.sub(num, 3, 3).."0"
return num
else
return string.sub(num, 3, 4)
end
elseif num == 1 then
return 100
elseif num > 999 then
num = string.sub(num, 1, string.len(num) - 3)..","..string.sub(num, string.len(num) - 2, string.len(num))
return num
elseif num == nil then
return 0
else 
return num
end
end

function MageCandy_CondenseNumber(num)
local length = string.len(num)
if num < 1000 then
return num
elseif num >= 1000 and num < 1000000 then
num = string.sub(num, 1, length - 3).."k"
return num
elseif num >= 1000000 then
num = string.sub(num, 1, length - 6).."m"
return num
end
end


function MageCandy_ScanUnit(unit, bufftype, caster, id)
local name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid
if bufftype == "debuff" then
for idx = 1, 40 do
name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitDebuff(unit, idx)
if name == nil then break end
if spellid == id and unitcaster == caster then
if duration == nil then duration = 0 end
if expiration == nil then expiration = 0 end
return duration, expirationtime
end
end
elseif bufftype == "buff" then
for idx = 1, 40 do
name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitBuff(unit, idx)
if name == nil then break end
if spellid == id then
if duration == nil then duration = 0 end
if expiration == nil then expiration = 0 end
return duration, expirationtime
end
end
else
return 0, 0
end
return 0, 0
end

-- And finally, set the event handler script and the main timer frame

CreateFrame("Frame", "MCTimer", UIParent)
MCTimer:SetScript("OnUpdate", MageCandy_MCTimerOnUpdate)
MCTimer:SetWidth(30)
MCTimer:SetHeight(30)
MCTimer:SetPoint("CENTER", UIParent, "CENTER")
MCTimer:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")

MageCandyEventFrame:SetScript("OnEvent", MageCandy_OnEvent)
end